#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>

/*
** o`
*/
#include "extrusion.h"

/*  */
static double spine[][3] = {
  { 0.0, 0.0, 0.0 },
  { 0.0, 1.0, 0.0 },
  { 2.0, 1.0, 0.0 },
  { 2.0, -1.0, 0.0 },
  { 2.0, -1.0, 2.0 },
};
#define NS (sizeof(spine) / (sizeof(double) * 3))

/* f*/
static double crossSection[][2] = {
  { -0.7, -0.7 },
  {  0.7, -0.7 },
  {  0.7,  0.7 },
  {  0.4,  0.7 },
  {  0.4, -0.4 },
  { -0.4, -0.4 },
  { -0.4,  0.7 },
  { -0.7,  0.7 },
  { -0.7, -0.7 },
};
#define NC (sizeof(crossSection) / (sizeof(double) * 2))

/* ̂̐F */
static GLfloat red[] = { 0.8, 0.2, 0.2, 1.0 };

/*
** gbN{[
*/
#include "quaternion.h"

/* hbOJnʒu */
static int cx, cy;

/* }EX̐ΈʒuEBhEł̑ΈʒůZW */
static double sx, sy;

/* }EX̑Έʒu]p̊ZW */
#define SCALE (2.0 * 3.14159265358979323846)

/* ]̏l (NH[^jI) */
static double cq[4] = { 1.0, 0.0, 0.0, 0.0 };

/* hbỎ] (NH[^jI) */
static double tq[4];

/* ]̕ϊs */
static double rt[16];

/*
** ̑ݒ
*/

/* ̈ʒu */
static GLfloat pos[] = { 0.0, 0.0, 1.0, 0.0 };

/* _̈ʒu */
static GLdouble ex = 0.0, ey = 0.0, ez = 10.0;

/* ڕW_̈ʒu */
static GLdouble tx = 0.0, ty = 0.0, tz = 0.0;

void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  /* fr[ϊs̏ */
  glLoadIdentity();

  /* _̈ړ */
  gluLookAt(ex, ey, ez, tx, ty, tz, 0.0, 1.0, 0.0);

  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, pos);

  /* ] */
  glMultMatrixd(rt);

  /* ` */
  glMaterialfv(GL_FRONT, GL_DIFFUSE, red);
  extrusion(crossSection, NC, spine, NS);

  glutSwapBuffers();
}

void resize(int w, int h)
{
  /* }EX|C^ʒũEBhȆΓIʒuւ̊Zp */
  sx = 1.0 / (double)w;
  sy = 1.0 / (double)h;

  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);

  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);

  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(30.0, (double)w / (double)h, 1.0, 100.0);

  /* fr[ϊs̎w */
  glMatrixMode(GL_MODELVIEW);
}

void idle(void)
{
  glutPostRedisplay();
}

void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* hbOJn_L^ */
      cx = x;
      cy = y;
      /* Aj[VJn */
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* Aj[VI */
      glutIdleFunc(0);
      /* ]̕ۑ */
      cq[0] = tq[0];
      cq[1] = tq[1];
      cq[2] = tq[2];
      cq[3] = tq[3];
      break;
    default:
      break;
    }
    break;
  default:
    break;
  }
}

void motion(int x, int y)
{
  double dx, dy, a;

  /* }EX|C^̈ʒũhbOJnʒu̕ψ */
  dx = (x - cx) * sx;
  dy = (y - cy) * sy;

  /* }EX|C^̈ʒũhbOJnʒű */
  a = sqrt(dx * dx + dy * dy);

  if (a != 0.0) {
    double ar = a * SCALE * 0.5;
    double as = sin(ar) / a;
    double dq[4] = { cos(ar), dy * as, dx * as, 0.0 };
    
    /* NH[^jI|ĉ] */
    qmul(tq, dq, cq);
    /* NH[^jI]̕ϊs߂ */
    qrot(rt, tq);
  }
}

void keyboard(unsigned char key, int x, int y)
{
  /* q, Q 邢 ESC ^CvI */
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    exit(0);
  }
}

void init(void)
{
  /* ݒ */
  glClearColor(1.0, 1.0, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);

  /* ]s̏ */
  qrot(rt, cq);
}

int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
